# GOAL: create a web server to handle queries
# This is a work is progress and is not complete.

import dotgenerator # from local directory 

from urlparse import urlparse, parse_qs

import BaseHTTPServer
from docutils import writers
from docutils.writers import html4css1
from docutils.core import publish_string

class SimpleHandler (BaseHTTPServer.BaseHTTPRequestHandler):
    server_version = "digbot 0"

    htmlwriter = writers.html4css1.Writer()
    r = dotgenerator.MyRunner() # from dotgenerator

    def html_interface(self):
        html = "<p><form action=\"\" method=\"get\">"
        html += "<input type=\"text\" name=\"query\">"
        html += "</form></p>"
        return html

    def do_HEAD(self):

        self.send_response(200)
        self.send_header("Content-type", "text/html")
        self.end_headers()

    def do_GET(self):
        args = parse_qs(urlparse(self.path).query)

        command="query"
        results = []

        self.do_HEAD()

        if(command in args):
            word = args[command][0]

            if (self.server.backref.reader is None):
                self.wfile.write("<p>Server not yet ready. Wait two minutes.</p>")
                return

            html_header = "<h3>%s</h3>\n" % (word)
            html_results = ""

            docutils_settings = {
                    'report_level: quiet'
            }

            num_results = 0
            for result in self.server.backref.query(word, "obj"):
                # NOTE: result is a DataCollectionManager from dotgenerator.py
                num_results += 1
                html_results += "<hr/>\n"
                html_results += "<h4>%s</h4>" % (result.title)
                html_results += publish_string(result.getText(), writer=self.htmlwriter, settings_overrides={}) # using settings_overrides causes a crash

            html_header +=  "<p>%d results found.</p>" %(num_results)

            self.wfile.write(html_header)
            self.wfile.write(html_results)

        else:
            # Not a query. Publish the HTML form. 
            self.wfile.write(self.html_interface())



class SimpleServer:

    # TODO: load and run in the background
    # TODO: receive queries from another process 
    # TODO: run building asynchronously so it can be queried

    runner = dotgenerator.MyRunner()
    reader = None

    def __init__(self, port=9999):

        self.httpd = BaseHTTPServer.HTTPServer(("", port), SimpleHandler)
        self.httpd.backref = self # HACK: Allow handler to see this object

        self.reload()

        self.httpd.serve_forever()

    def reload(self):
        print "Loading data from disk..."
        reader = self.runner.run()
        # print "Building references..." # echoed in sub function
        reader.buildReferences()
        print "...Done loading data."
        self.reader = reader


    def query(self, key, request="ref"):
        if(self.reader is None):
            return None

        return self.reader.query(key, request)



def __main___bak(): 

    r = MyRunner.run() 
    # r = timedfunction(MyRunner.run)

    if len(sys.argv) > 1:
        run_query(r, sys.argv[1])
    else:
        run_dotfile(r)

# cProfile.run( '__main__()' ) 

# __main__()

try:
    t = SimpleServer()
except KeyboardInterrupt:
    pass

#t.httpd.server_close()
